;
; TUTScheme Condition system product version 11.0
;     By N.Watanabe
;     1993/04/15    version 11.0
;     file No.1 

;;;(define *return-sctop*)

(define entry-condition)
(define get-condition)
(define get-condition-parent)       ; version 10.0
(define get-condition-superclass)   ; version 10.0
(define get-condition-slot)         ; version 11.0
(define get-condition-slot1)        ; version 9.0
(define get-condition-slot2)        ; version 9.0
(define init-condition)
(define condition?)

;  Condition object closuer.
;  include some accece function.
;    Remake version 8. 92/10/30
(let ((condition-list '()))
  (define (remove condition-name obj)  ; New version 6. 92/10/06
    (cond ((null? obj) '())
          ((eq? condition-name (caar obj))
           (cdr obj))
          (else
            (cons (car obj) 
                  (remove condition-name (cdr obj))))))
  (define (append-condition-list object) ; Remake version 8.0 92/10/30
    (cond ((null? condition-list)
           (set! condition-list 
                 (list object)))
          ((condition-object? object)
           (set! condition-list
                 (remove (condition-class object) 
                         condition-list))
           (set! condition-list 
                 (cons object
                       condition-list)))
          (else
            (set! condition-list 
                  (cons object
                        condition-list)))))
  (set! entry-condition         ; version 9.0 92/11/21
    (lambda (type parents slot1 slot2 option)
      (let ((errmsg '()))
        (cond ((not (symbol? type))
               (set! errmsg "1st argument must be a symbol."))
              ((not (list? parents))
               (set! errmsg "2nd argument must be a list."))
              ((not (list? slot1))
               (set! errmsg "3rd argument must be a list."))
              ((not (list? slot2))
               (set! errmsg "4th argument must be a list."))
              ((not (function? option))
               (set! errmsg "5th argument must be a function.")))
        (if (null? errmsg)
            (append-condition-list
              (list type parents slot1 slot2 option))
            (error 'illegal-argument
                   'function entry-condition
                   'arguments (list type parents slot1 slot2 option)
                   'message errmsg)))))
  (set! get-condition 
    (lambda (condition-name)
      (if (null? condition-name)
          condition-list
          (if (condition? condition-name)
              (let ((obj (assq condition-name condition-list)))
                (list (car obj)
                      (append (caddr obj) (cadddr obj))
                      (cadr (cdddr obj))))
              (error 'illegal-argument
                     'function get-condition
                     'arguments (list condition-name)
                     'message "Argument must be a condition.")))))
  (set! get-condition-parent
    (lambda (name)
      (if (condition? name)
          (caadr (assq name condition-list))
          #f)))
  (set! get-condition-superclass
    (lambda (name)
      (if (condition? name)
          (cadr (assq name condition-list))
          #f)))
  (set! get-condition-slot          ; version 11.0
    (lambda (class)
      (if (not (condition? class))
	  (error 'illegal-argument
		 'function get-condition-slot
		 'arguments (list class)
		 'message "Argument must be a condition.")
	  (append (caddr (assq class condition-list))
		  (cadddr (assq class condition-list))))))
  (set! get-condition-slot1         ; version 9.0
    (lambda (type)
      (if (condition? type)
          (caddr (assq type condition-list))
          (error 'illegal-argument
                 'function get-condition-slot1
                 'arguments (list type)
                 'message "Argument must be a condition."))))
  (set! get-condition-slot2          ; version 9.0
    (lambda (type)
      (if (condition? type)
          (cadddr (assq type condition-list))
          (error 'illegal-argument
                 'function get-condition-slot2
                 'arguments (list type)
                 'message "Argument must be a condition."))))
  (set! init-condition
    (lambda ()
      (set! condition-list '())))
  (set! condition?
    (lambda(condition-name)
      (cond ((null? condition-name)    ;  version 8.2 92/11/11
             #t)                       ;  
            ((not (assq condition-name condition-list)) 
             #f) 
            (else 
              #t)))))

;
; TUTScheme Condition system product version 8.0
;     By N.Watanabe
;     1992/11/11    version 8.2
;     file No. 2				


;  Define a condition type and append it to condition list.
;      Remake version 5. 92/10/02
(macro define-condition 
  (lambda (form)
    (let ((name (cadr form))
          (parents (caddr form))
          (slots-and-report (cdddr form)))
      `(define-condition** (quote ,name) 
                           (quote ,parents) 
                           (quote ,slots-and-report)))))
                           
;  Remake version 5. 92/10/02
(define (define-condition** name parents rest)
  (define (make-parents-slot)
    (let ((parent-slot '()))
      (if (not (null? parents))
          (for-each 
            (lambda (sc)
              (for-each 
                (lambda (y)
                  (let ((slot (assq (car y) parent-slot)))
                    (if (not slot)
                        (if (null? parent-slot)
                            (set! parent-slot (list y))
                            (set! parent-slot 
                                  (append parent-slot (list y)))))))
                (get-condition-slot sc))) 
            parents))
      parent-slot))
  (define (make-slot x)
    (cond ((symbol? x) (cons x '()))
          ((pair? x)    x)
          (else (cons '() '())))) ; syntax error!
  (define (make-report-obj report) ; ver.6
    (let ((report-obj '()))
      (cond ((null? report)
             (set! report-obj (lambda (c s) 
                                (format s "No report option.(~a)~&" 
                                  (conditon-class c)))))
            ((string? report)
             (set! report-obj (lambda (c s)
                                (format s report))))
            (else
              (set! report-obj (eval report))))
      (if (function? report-obj)
          (if (not (= (function-arginfo report-obj) 12))
              (error "~a is illegal condition report function." report)
              report-obj)
          (error "system error in make-report-obj."))))

  (let ((slot1 '())    
        (slot2 '())    
        (report '()))  
    (if (not (null? rest))
        (begin (set! slot1  (map make-slot (car rest)))
               (set! slot2  (make-parents-slot))
               (set! report (make-report-obj (cadr rest)))))
    (entry-condition name parents slot1 slot2 report)
    #t))

;  Make a condition object.
;
(define (make-condition condition-name . args)
  (define (set-value object slot)
    (cond ((null? slot) '())
          ((symbol? (car slot))  ; symbol.
           (if (even? (length slot))
             (begin 
               (set-slot! object (car slot) (cadr slot))
               (set-value object (cddr slot)))
             (error "unrecognized syntax function make-condition ."))) 
          ((pair? (car slot))    ; dot pair.
           (set-slot! object (caar slot) (cdar slot))
           (set-value object (cdr slot)))
          (else 
            (error "Syntax error in make-condition."))))
  (cond ((not (condition? condition-name))
         (error "non-condition."))
        (else
          (let* ((original (get-condition condition-name))
                 (slots  (condition-slots   original))
                 (report (get-condition-report-obj original))
                 (object '()))
            (set! slots (map (lambda (a)
                               (cons (car a)(cdr a)))
                             slots))
            (set! object (list condition-name slots report))
            (if (not (null? args)) 
                (set-value object args))
            object))))

;
; TUTScheme Condition system product version 9.0
;     By N.Watanabe
;     1992/11/21    version 9.0
;     1994/04/12    Update
;   File No.3


;  Check condition object or not.
;
(define (condition-object? condition)
  (if (and (list? condition)
           (= (length condition) 3)
           (condition? (car condition)))
      #t 
      #f))

;
;   version 8.2  92/11/11
(define (condition-class? c1 c2)
  (let ((c1-type c1)
        (c2-type c2)
        (errmsg  '()))
    (cond ((not (or (condition? c1) (condition-object? c1)))
           (set! errmsg "1st argument must be a condition."))
          ((not (or (condition? c2) (condition-object? c2)))
           (set! errmsg "2nd argument must be a condition.")))
    (cond ((null? errmsg)
           (if (condition-object? c1)
               (set! c1-type (condition-class c1)))
           (if (condition-object? c2)
               (set! c2-type (condition-class c2)))
           (if (eq? c1-type c2-type)
               #t
               #f))
          (else
            (error 'illegal-argument
                   'function condition-class?
                   'arguments (list c1 c2)
                   'message errmsg)))))

;
;    version 9.0  92/11/21
(define (condition-superclass? c1 c2)
  (define (superclass? type1 type2)
    (let ((type2-parent (condition-parent type2)))
      (cond ((or (null? type2) (null? type2-parent)) #f)
            ((eq? type2-parent type1) #t)
            (else
              (superclass? type1 type2-parent)))))
  (define (direct-superclass? type1 parents)
    (cond ((null? parents)           #f)
          ((eq? type1 (car parents)) #t)
          (else (direct-superclass? type1 (cdr parents)))))
  (let ((c1-type c1)
        (c2-type c2)
        (parents '())
        (errmsg  '()))
    (cond ((not (or (condition? c1) (condition-object? c1)))
           (set! errmsg "1st argument must be a condition."))
          ((not (or (condition? c2) (condition-object? c2)))
           (set! errmsg "2nd argument must be a condition.")))
    (cond ((null? errmsg)
           (if (condition-object? c1)
               (set! c1-type (condition-class c1)))
           (if (condition-object? c2)
               (set! c2-type (condition-class c2)))
           (set! parents (cdr (condition-direct-superclass c2-type)))
           (or (superclass?        c1-type c2-type)
               (direct-superclass? c1-type parents)))
          (else
            (error 'illegal-argument
                   'function condition-superclass?
                   'arguments (list c1 c2)
                   'message errmsg)))))

;
;    version 9.0  92/11/21
(define (condition-subclass? c1 c2)
  (define (subclass? type1 type2)
    (let ((type1-parent (condition-parent type1)))
      (cond ((or (null? type1) (null? type1-parent)) #f)
            ((eq? type1-parent type2) #t)
            (else
              (subclass? type1-parent type2)))))
  (define (direct-superclass? type1 parents)
    (cond ((null? parents)           #f)
          ((eq? type1 (car parents)) #t)
          (else (direct-superclass? type1 (cdr parents)))))
  (let ((c1-type c1)
        (c2-type c2)
        (parents '())
        (errmsg  '()))
    (cond ((not (or (condition? c1) (condition-object? c1)))
           (set! errmsg "1st argument must be a condition."))
          ((not (or (condition? c2) (condition-object? c2)))
           (set! errmsg "2nd argument must be a condition.")))
    (cond ((null? errmsg)
           (if (condition-object? c1)
               (set! c1-type (condition-class c1)))
           (if (condition-object? c2)
               (set! c2-type (condition-class c2)))
           (set! parents (cdr (condition-direct-superclass c1-type)))
           (or (subclass?          c1-type c2-type)
               (direct-superclass? c2-type parents)))
          (else
            (error 'illegal-argument
                   'function condition-subclass?
                   'arguments (list c1 c2)
                   'message errmsg)))))
   
;  Condition Object access functions.

;  Get condition class name from condition object.
;
(define (condition-class object)
  (if (condition-object? object)
      (car object)
      (error "~a is not a condition object" object)))

;  Get main-superclass name from condition object.
;    Extened version 8.1 , 10.0
(define (condition-parent condition)
  (cond ((condition? condition)
         (get-condition-parent condition))
        ((condition-object? condition)
         (get-condition-parent (condition-class condition)))
        (else
          (error 'illegal-argument
                 'function condition-parent
                 'arguments (list condition)
                 'message "Argument must be a condition."))))

;  Return a superclass-list of specified class.
;                     [NEW]   1994/04/12  By N.Watanabe
(define (condition-superclass condition)
  (define (exist? head rest)
    (if (null? rest)
        #f
        (if (eq? head (car rest))
            #t
            (exist? head (cdr rest)))))
  (define (bar class-list)  ;;; remove same member in list.
    (let ((head (car class-list))
          (rest (cdr class-list)))
      (if (null? class-list)
          '()
          (if (exist? (car class-list) (cdr class-list))
              (bar (cdr class-list))
              (cons (car class-list) (bar (cdr class-list)))))))
  (define (foo class-list)  ;;; return list of superclass.
    (if (null? class-list)
        '()
        (append (list (car class-list))
                (foo (cdr class-list))
                (foo (condition-direct-superclass (car class-list))))))
  (cond ((condition? condition)
	 (bar (append (list condition)
		      (foo (condition-direct-superclass condition)))))
        ((condition-object? condition)
	 (bar (append (list (condition-class condition))
		      (foo (condition-direct-superclass 
			     (condition-class condition))))))
        (else 
          (error 'illegal-argument
                 'function condition-superclass
                 'arguments (list condition)
                 'message "Argument must be a condition."))))

;  Get directsuperclass from condition object.
;                        [UPDATE]  1994/04/12 By N.Watanabe
(define (condition-direct-superclass condition)  
  (cond ((condition? condition)
         (get-condition-superclass condition))
        ((condition-object? condition)
         (get-condition-superclass (condition-class condition)))
        (else 
          (error 'illegal-argument
                 'function condition-direct-superclass
                 'arguments (list condition)
                 'message "Argument must be a condition."))))

;  Get slot information from condition object.
;
(define (condition-slots object)
  (if (condition-object? object) 
      (cond ((null? object) '())
            ((eq? object #f)
             (error "~&undefined-condition. ~a~&" object))
            (else 
              (cadr object)))
      (error "undefined-condition.")))

;  Get slot list length.
;    version 6.1 92/10/07
(define (number-of-slots object)
  (cond ((condition-object? object)
         (length (condition-slots object)))
        ((condition? object)
         (length (condition-slots (get-condition object))))
        (else
          0)))

;  Get a list of slot name from condition object.
;    version 6.1  92/10/07
(define (slot-name-list object)
  (define (slot-name-list* slot)
    (if (null? slot)
        '()
        (cons (caar slot) (slot-name-list* (cdr slot)))))
  (if (condition-object? object) 
      (slot-name-list* (condition-slots object))
      #f)) ; argument 'object' is not a condition object.

;  Get a value from slot of condition object.
;
(define (slot-value object slot-name)
  (let ((value (assq slot-name (condition-slots object))))
    (if (eq? value #f)
        (error "slot-missing(~a).~%" slot-name)
        (cdr value))))

;  Get a list of slot value from the slot of condition object.
;
(define (slot-value-list object)
  (define (_slot-value-list slot)
    (if (null? slot)
        '()
        (cons (cdar slot) (_slot-value-list (cdr slot)))))
  (if (condition-object? object) 
      (_slot-value-list (condition-slots object))
      #f))


;  Check the object slot exist or not.
;  If the slot exists, return value of #t else #f.
(define (slot-exists? object slot-name)
  (if (assq slot-name (condition-slots object))
      #t
      #f))

;  Set new slot value to the condition object's slot.
;
(define (set-slot! object slot-name value)
  (let ((slot (condition-slots object))
        (tmp '()))
    (if (slot-exists? object slot-name)
        (begin (set! tmp (assq slot-name slot))
               (set-cdr! tmp value))
        (error "slot-missing(~a).~%" slot-name)))) ; when the slot nonexists.

;  Get condition report object from the given object.
;    New function version 5.  92/10/02
(define (get-condition-report-obj object)
  (if (not (condition-object? object))
      (error 'illegal-argument
             'function get-condition-report-obj
             'arguments (list object)
             'message "Argument must be a condition object.")
      (if object
          (caddr object)
          (error "Undefined condition." ))))

;  Write condition report.
;    Remake version 5.  92/10/02
(define (condition-report condition stream)
  (if (not (condition-object? condition))
      (error 'illegal-argument
             'function  condition-report
             'arguments (list condition stream)
             'message "1st argument must be a condition object.~&")
      (let ((report-obj (get-condition-report-obj condition))
            (header-str "Error :"))
        (cond ((or (condition-class? condition 'system-error)
                   (condition-subclass? condition 'system-error))
               (set! header-str "System error: "))
              ((or (condition-class? condition 'error)
                   (condition-subclass? condition 'error))
               (set! header-str "Error:  "))
              ((or (condition-class? condition 'break)
                   (condition-subclass? condition 'break))
               (set! header-str "Break:  "))
              ((or (condition-subclass? condition 'warning)
                   (condition-class? condition 'warning))
               (set! header-str "Warning: "))
              (else
                (set! header-str "Condition : ")))
        (if (= (function-arginfo report-obj) 12)
            (begin (format stream "~&~a" header-str)
                   (report-obj condition stream)
                   (format stream "~&")
                   #t)
            (error "Illegal condition report function ~a" report-obj)))))

;  Function to make condition object symbol.
;
(define (condition-symbol condition-obj)
  (if (not (condition-object? condition-obj))
      (error 'illegal-argument
             'function condition-symbol
             'arguments (list condition-obj)
             'message "Argument must be a condition object.~a")
      (let ((type-name (condition-class condition-obj)))
        (string->symbol (format #f "#<condition:~a>" type-name)))))
;
(define (write-condition condition-obj)
  (if (not (condition-object? condition-obj))
      (error 'illegal-argument
             'function write-condition
             'arguments (list condition-obj)
             'message "Argument must be a condition object.~&")
      (let ((type-name (condition-class condition-obj)))
        (format #t "#<condition:~a>" type-name))))

;  Get function name from function object
;    New function since version 6.
(define (get-function-name function-obj)
  (cond ((null? function-obj) "<not-procedure>")
        ((function? function-obj)
         (let ((fun-def (cadr (function-definition function-obj))))
           (string->symbol (if (null? fun-def)
                               "<non-name-function>"
                               fun-def))))
        (else
          (error 'illegal-argument         ;  not function object.
                 'function get-function-name
                 'arguments (list function-obj)
                 'message "Function object required."))))
  
;  Condition Accessor
;
(define (error-function condition)
  (cond ((not (condition-object? condition))
         (error 'illegal-argument
                'function  error-function
                'arguments (list condition)))
        (else
          (slot-value condition 'function))))

(define (error-arguments condition)
  (cond ((not (condition-object? condition))
         (error 'illegal-argument
                'function  error-arguments
                'arguments (list condition)))
        ((condition-subclass? condition 'error)
         (slot-value condition 'arguments))))

(define (argument-number condition)
  (cond ((not (condition-object? condition))
         (error 'illegal-argument
                'function  argument-number
                'arguments (list condition)))
        ((condition-class? condition 'illegal-number-of-arguments)
         (slot-value condition 'argument-number))
        ((condition-subclass? condition 'error)
         (length (slot-value condition 'arguments)))
        (else
          (wran "Invalid condition type ~a in argument-number."
                (condition-symbol condition)))))

(define (stream-error-stream condition)
  (let ((errmsg '()))
    (cond ((not (condition-object? condition))
           (set! errmsg "Argument must be a condition object."))
          ((not (or (condition-subclass? condition 'stream-error)
                    (condition-class?    condition 'stream-error)))
           (set! errmsg "Argument must be a stream-error condition.")))
    (cond ((null? errmsg)
           (slot-value condition 'stream))
          (else
            (error 'illeagal-argument
                   'function stream-error-stream
                   'arguments (list condition)
                   'message errmsg)))))

(define (file-error-pathname condition)
  (let ((errmsg '()))
    (cond ((not (condition-object? condition))
           (set! errmsg "Argument must be a condition object."))
          ((not (or (condition-subclass? condition 'file-error)
                    (condition-class?    condition 'file-error)))
           (set! errmsg "Argument must be a file-error condition.")))
    (cond ((null? errmsg)
           (slot-value condition 'pathname))
          (else
            (error 'illeagal-argument
                   'function file-error-pathname
                   'arguments (list condition)
                   'message errmsg)))))


;  TUTScheme error handler system product version 7.0
;      By N.Watanabe
;      1992/12/01
;      File No. 1    

(define *break-on-signals*)

(define *handler-enable* #t) ; *handler-enable* = { #t , #f }
                             ;   #t : enable
                             ;   #f : disable

;(define _call/cc call/cc)
;(define _call-with-current-continuation call-with-current-continuation)

(define (call/cc-cs fun)
  (let* ((tmp1 *handler-stack*)
         (tmp2 *debugger-level*)
         (tmp3 *dbg-cont-stack*)
         (tmp4 *condition-stack*)
         (ret-value (call/cc fun)))
    (set! *handler-stack* tmp1)
    (set! *debugger-level* tmp2)
    (set! *dbg-cont-stack* tmp3)
    (set! *condition-stack* tmp4)
    (set! *return-debugger* (car *dbg-cont-stack*))
    ret-value))

(define call-with-current-continuation-on-condition-system call/cc-cs)
                             
(macro let/cc-cs               ;  let/cc2 version 2.1 92/11/13
  (lambda (form)
    (let ((var (cadr form))
          (body (cddr form)))
      `(let* ((tmp1 *handler-stack*)
              (tmp2 *debugger-level*)
              (tmp3 *dbg-cont-stack*)
              (tmp4 *condition-stack*)
              (ret-value (call/cc (lambda (,var) ,@body))))
         (set! *handler-stack* tmp1)
         (set! *debugger-level* tmp2)
         (set! *dbg-cont-stack* tmp3)
         (set! *condition-stack* tmp4)
         (set! *return-debugger* (car *dbg-cont-stack*))
         ret-value))))

(define push-handler)
(define push-global-handler)
(define get-global-handler-stack)
(define set-global-handler-stack!)
(define _remove-handler)

(define *handler-stack* '())

(define (get-handler-stack)
  *handler-stack*)

(define (set-handler-stack! handler)
  (set! *handler-stack* handler))

(let ((global-handler-stack '()))
  (define (remove class stack)
    (cond ((null? (cdr stack)) '())
          ((eq? (caadr stack) class)
           (set-cdr! stack (cddr stack))
           (remove class stack))))
  (set! push-handler
        (lambda (name handler)
          (set! *handler-stack* (cons (cons name
					    handler)
                                    *handler-stack*))))
  (set! push-global-handler
        (lambda (name handler)
          (set! global-handler-stack (cons (cons name
                                                 handler)
                                    global-handler-stack))))
  (set! get-global-handler-stack
        (lambda ()
          global-handler-stack))
  (set! set-global-handler-stack!
        (lambda (handler)
          (set! global-handler-stack handler)))
  (set! _remove-handler
        (lambda (class)
          (cond ((null? global-handler-stack) #f)
                ((eq? (caar global-handler-stack) class)
                 (remove class global-handler-stack)
                 (set! global-handler-stack (cdr global-handler-stack))
                 #t)
                (else 
                  (remove class global-handler-stack)
                  #t)))))

;
;  Define a global condition handler.
;
(macro define-handler 
  (lambda (form)
    (let ((condition-class (cadr form))
          (handler         (caddr form)))
      `(define-handler* (quote ,condition-class)
                        ,handler))))
			 
(define (define-handler* condition-class handler)
  (cond ((not (condition? condition-class))
         (error 'illegal-argument-type
                'function  define-handler
                'arguments (list condition-class handler)
                'object    condition-class
                'type      "condition type name"))
        ((not (function? handler))
         (error 'illegal-argument-type
                'function  define-handler
                'arguments (list condition-class handler)
                'object    handler
                'type      "condition report function"))
        ((not (= (function-arginfo handler) 8))
         (error 'illegal-argument-type
                'function define-handler
                'arguments (list condition-class handler)
                'object handler
                'type   "function with one argument" ))
        (else
          (if (= *debugger-level* 0)
              (push-global-handler condition-class handler)
              (push-handler condition-class handler))
          #t)))

;  Remove a global condition handelr.
;
(macro remove-handler 
  (lambda (form)
    (let ((condition-class (cadr form)))
      `(remove-handler* (quote ,condition-class)))))
                        
(define (remove-handler* condition-class)
  (if (not (condition? condition-class))
      (error 'illegal-argument-type 
             'function remove-handler 
             'arguments (list condition-class)
             'object    condition-class
             'type      "condition type name")
      (_remove-handler condition-class)))

(define *handler-scope* 0)  ;;;  

;  Error handler bind macro.
;    version 7.0  93/12/12
(macro handler-bind
  (lambda (form)
    (let ((handler (cadr form))
          (body    (cddr form)))
      `(let ((tmp (get-handler-stack)))
         (if (= *handler-scope* 1)        ;;;
             (set! *handler-stack* '()))    ;;;
	 (handler-bind/case* 
	   (map list ',(map car handler)
	     (map (lambda (thunk) thunk)
	       (list ,@(map (lambda (b) (list (list 'lambda '() (cadr b))))
	                 handler)))))
         (let ((retval (begin ,@body)))
           (set! *handler-stack* tmp)
           retval)))))

;  handler-case macro.
;    UPDATE 94/04/14 By N.Watanabe
(macro handler-case
  (lambda (form)
    (let ((expression (cadr form))
          (handler    (cddr form)))
      `(let ((tmp (get-handler-stack)))
         (if (= *handler-scope* 1)        
             (set! *handler-stack* '())) 
         (handler-bind/case*
           (map list 
             ',(map car handler)
             (map (lambda (thunk) thunk)
               (list 
                 ,@(map (lambda (b) 
                          (list (list 'lambda '() 
                                      (cons 'lambda 
                                            (cons (if (null? (cadr b))
                                                      '(_dummy-var)
                                                      (cadr b))
                                                  (cddr b))))))
                     handler)))))
         (let ((retval ,expression))
           (set! *handler-stack* tmp)
           retval)))))

;  Bind handler function object to condition handler.
;  version 1.0  93/12/12  By N.Watanabe 
(define (handler-bind/case* handler)
  (define (handler-bind-sub x)
    (let ((name (car x))
          (handler-obj (cadr x)))
      (if (not (= (function-arginfo handler-obj) 8))
          (error "Illegal handler function. (handler-bind)")
          (push-handler name handler-obj))))
  (for-each handler-bind-sub handler))

;  Make handler object and bind it to condition handler .
;    Remake version 6.2 1992/11/05  ### NOT USED SINCE 93/12/12 ###
(define (handler-bind* handler)
  (define (handler-bind-sub x)
    (let ((name (car x))
          (body (cadr x))
          (handler-obj '()))
      (cond ((null? body)
             (set! body (cons 'lambda (cons '(*dumy-args) '()))))
            ((and (list? body) 
                  (eq? (car body) 'lambda) 
                  (null? (cadr body)))
             (set! body (cons 'lambda (cons '(*dumy-args) (cddr body))))))
      (set! handler-obj (eval body))
      (if (not (= (function-arginfo handler-obj) 8))
          (error "Illegal handler function ~a. (handler-bind)" body)
          (push-handler name handler-obj))))
  (for-each handler-bind-sub handler))

;  Make handler object list and bind it to handl binder.
;    Remake version 4. 1992/10/03  ### NOT USED SINCE 93/12/12 ###
(define (handler-case* handler)
  (define (handler-case-sub x) 
    (let ((name (car x))
          (body (cdr x))
          (handler-obj '()))
      (if (null? (car body))
          (set! body (cons 'lambda (cons '(*dumy-args) (cdr body))))
          (set! body (cons 'lambda body)))
      (set! handler-obj (eval body))
      (if (not (= (function-arginfo handler-obj) 8))
          (error "Illegal handler function. (handler-case)")
          (push-handler name handler-obj))))
  (for-each handler-case-sub handler))

;
;  TUTScheme error handler system product version 7.0
;      By N.Watanabe
;      1992/12/01
;      1994/04/12  UPDATE
;      File No.2    

;
;
(macro ignore-errors 
  (lambda (body)
    (let ((forms (cdr body)))
      `(handler-case (begin ,@forms)
         (error (c) c)))))

;  Error condition signal function.
;
(define (error datum . arguments)
  (let ((condition-obj '())
        (report-obj '())
        (name '())
        (return-value '()))
    (if (null? (get-condition '())) (error-break))
    (cond ((string? datum)
           (set! condition-obj 
                 (make-condition 'simple-error
                                 'format-string datum
                                 'format-arguments arguments)))
          ((condition-object? datum)
           (set! condition-obj datum))
          ((condition? datum)
           (set! condition-obj
                 (apply make-condition datum arguments)))
          (else
            (error 'illegal-argument
                   'function error
                   'arguments (list datum arguments)
                   'message "1st argument must be a string or a condition.")))
    (if (not (condition-object? condition-obj))
        (error "System-error in (error)")
        (begin
	  (set! *condition* condition-obj) ;;; 1994/04/12 
          (set! return-value (error-handler condition-obj))
          return-value))))

;  Find condition handler.
;    version 7.0  
(define (find-condition-handler object)
  (define (find-handler  type-list)
    (if (null? type-list)
        '()
        (let ((handler-pair (assq (car type-list) 
                                  (append (get-handler-stack) 
                                          (get-global-handler-stack)))))
          (if handler-pair 
              (cdr handler-pair)
              (find-handler (cdr type-list))))))
  (define (find-handler2 type)
    (if (null? type) 
        '()
        (let ((a (assq type (append (get-handler-stack)  ;;;
                                    (get-global-handler-stack))))) ;;;
          (if a 
              (cdr a)
              (find-handler2 (condition-parent type))))))
  (if (not (condition-object? object))
      (error 'illegal-argument
             'function find-condition-handler
             'arguments (list object)
             'message "Argument must be a condition object.")
      (let* ((name    (condition-class object))
             (parents (condition-direct-superclass object))
             (a       (cons name parents))
             (handler (find-handler a)))
        (if (null? handler)
            (find-handler2 (condition-parent object))
            handler))))

;  Error handler 
;    Remake version 6.5 
(define (error-handler condition)
  (let ((handler (find-condition-handler  condition)))
    (cond ((and (not (null? handler))
                *handler-enable*)
           (handler-exec handler condition))
          ((eq? *debug-level* 0) ; print error message and return top level.
           (condition-report condition *error-output*)
           (return-to-sctop))
          ((eq? *debug-level* 1) ; print error message , back trace
           (condition-report condition *error-output*) ; and return sctop.
           (back-trace)
           (return-to-sctop))
          ((eq? *debug-level* 2)
           (invoke-debugger condition))
          (else
            (warn "*debug-level* has an invalid value ~s." *debug-level*)
            (invoke-debugger condition)))))

;  Execute handler procudure 
;    Remake version 4. 92/10/03
(define (handler-exec handler condition)
  (let ((return-value '())
        (handler-saver '()))
    (set! handler-saver (get-handler-stack))  ; version 6.4  92/11/10
    (set! *handler-stack* '())                ; 
    (set! return-value (handler condition)) ; version 4  92/10/03
    (set! *handler-stack* handler-saver) ; version 6.4 92/11/10
    return-value))

;  Condition handler
;
(define (condition-handler condition)
  (let ((handler (find-condition-handler condition)))
    (if (null? handler) 
        #f           ; when no handler exists, return #f
        (handler-exec handler condition))))


;  Break function.
;    version 6.1  92/11/05
(define (break . args)
  (let ((format-string "There is a break function.")
        (format-arguments '())
        (env '())
        (tmp '())
        (condition '()))
    (if (null? args)
        (set! condition
              (make-condition 'break
                              'format-string    format-string
                              'format-arguments format-arguments))
        (cond ((string? (car args))
               (set! condition
                     (make-condition 'break
                                     'format-string    (car args)
                                     'format-arguments (cdr args))))
              ((condition-object? (car args))
               (set! condition (car args)))
              (else
                (set! condition '()))))
    (cond ((null? condition)
           (error 'illegal-argument
                  'function break
                  'arguments args
                  'message "1st argument must be a string or a condition."))
          ((not (condition-object? condition))
           (error "System error in break."))
          (else
	    (set! *condition* condition) ;;; 1994/04/12 
            (set! tmp (condition-handler condition))
            (if tmp
                tmp
                (invoke-debugger condition))))))

;  Warn function.
;    version 6.1  92/11/05
(define (warn . args)
  (let ((format-string "No message has been supplied.")
        (format-arguments '())
        (tmp  '())
        (condition  '()))
    (if (not (null? args))
        (if (not (string? (car args)))
            (error 'illegal-argument
                   'function warn
                   'arguments args
                   'message "1st argument must be a string.")
            (begin
              (set! format-string (car args))
              (set! format-arguments (cdr args)))))
    (set! condition
                  (make-condition 'simple-warning
                                  'format-string    format-string
                                  'format-arguments format-arguments))
    (set! *condition* condition) ;;; 1994/04/12 
    (set! tmp (condition-handler condition))
    (if tmp
        tmp
        (condition-report condition *error-output*))))

;  Condition signal function.
;    version 6.3  92/11/06.
(define (signal datum . arguments)
  (let ((condition-obj '())
        (report-obj '())
        (name '())
        (return-value '()))
    (cond ((string? datum)
           (set! condition-obj 
                 (make-condition 'simple-error
                                 'format-string datum
                                 'format-arguments arguments)))
          ((condition-object? datum)
           (set! condition-obj datum))
          ((condition? datum)
           (set! condition-obj
                 (apply make-condition datum arguments)))
          (else
            (error 'illegal-argument
                   'function signal
                   'arguments (list datum arguments)
                   'message "1st argument must be a string or a condition.")))
    (if (not (condition-object? condition-obj))
        (error "System error in signal function.~&")
        (begin
	  (set! *condition* condition-obj) ;;; 1994/04/12 
          (if (condition-subclass? condition-obj *break-on-signals*)
              (invoke-debugger condition-obj))
          (set! return-value (condition-handler condition-obj))
          return-value))))

;  Return to top level loop.  
;
(define (return-to-sctop)
  (set! *debugger-level* 0)
  (set! *dbg-cont-stack* '())
  (set! *condition-stack* '())
  (return-sctop))

;  Signal the Compile error condition.
;
(define (scerror s . args)
  (error 'compile-error
         'format-string s
         'format-arguments args)
  (return-to-sctop))

;
;  Condition definition.
;    By N.Watanabe 
;       1992/10/14
;

;
;  The function for Condition report. 
;

(define (std-error-report condition stream message)
  (format stream 
          "~a~%" message)
  (if *user-exec* 
      (std-error-function-report condition stream)))

(define (std-error-function-report condition stream)
  (cond ((condition-subclass? condition 'error)
         (format stream "        In (~a" 
           (handler-bind ((illegal-argument
                            (lambda (c) "<not-procedure>")))
             (get-function-name (slot-value condition 'function))))
         (for-each (lambda (x)
                     (format stream " ~s"
                       (cond ((condition-object? x)
                              (condition-symbol x))
                             (else
                               x))))
                   (slot-value condition 'arguments))
         (format stream ").~&"))))

;
;  Condition definition.
;

(define-condition 
  condition () 
  ()
  (lambda (condition stream)
    (format stream "Signalled CONDITION(~a).~&"
		   (condition-class condition))))

(define-condition
  simple-condition (condition)
  (format-string format-arguments)
  (lambda (c s)
    (apply format s (slot-value c 'format-string)
                    (slot-value c 'format-arguments))))

(define-condition
  break (simple-condition)
  ((env . ()))
  (lambda (c s)
    (apply format s (slot-value c 'format-string)
                    (slot-value c 'format-arguments))))

(define-condition 
  warning (condition)
  ()
  "WARNING.")

(define-condition
  simple-warning (warning simple-condition)
  ()
  (lambda (c s)
    (apply format s (slot-value c 'format-string)
                    (slot-value c 'format-arguments))))

(define-condition
  serious-condition (condition)
  ()
  "SERIOUS-CONDITION.")

(define-condition
  storage-condition (serious-condition)
  ()
  "STORAGE-CONDITION.")

(define-condition
  stack-over-flow (storage-condition)
  ()
  "STACK-OVER-FLOW.")

(define-condition 
  error (serious-condition)
  (function arguments)
  (lambda (c s)
    (std-error-report c s "ERROR.")))

(define-condition 
  simple-error (error simple-condition) 
  ()
  (lambda (condition stream)
    (let ((format-string    (slot-value condition 'format-string))
          (format-arguments (slot-value condition 'format-arguments))
          (function         (slot-value condition 'function))
          (args             (slot-value condition 'arguments)))
      (if (and (string? format-string) (list? format-arguments))
          (apply format stream format-string format-arguments)
          (format stream "SIMPLE-ERROR CONDITION.")))))

(define-condition 
  byte-code-error (error)
  (byte-code-function)
  "BYTE-CODE-ERROR")

(define-condition 
  not-function-apply (error)
  ()
  (lambda (c s)
    (format s "~s is not a function.~%" (slot-value c 'function))
    (std-error-function-report c s)))

(define-condition
  symbol-error (error)
  (object)
  "SYMBOL-ERROR")

(define-condition 
  unbound-symbol (symbol-error)
  ()
  (lambda (c s)
    (format s "~a is an unbound symbol.~&"
	    (slot-value c 'object))
    (std-error-function-report c s)))

(define-condition
  unbound-symbol-bci (symbol-error byte-code-error)
  ()
  (lambda (c s)
    (format s "~a is an unbound symbol.~&"
	    (slot-value c 'object))
    (format s "        in byte code instruction ~a.~&" 
	    (slot-value c 'byte-code-function))))

(define-condition 
  not-ordinary-symbol (symbol-error)
  ()
  (lambda (c s)
    (format s "~a is an unbound symbol.~&"
	    (slot-value c 'object))
    (std-error-function-report c s)))

(define-condition
  not-ordinary-symbol-bci (symbol-error byte-code-error)
  ()
  (lambda (c s)
    (format s "~a is not an ordinary symbol.~&"
	    (slot-value c 'object))
    (format s "        in byte code instruction ~a.~&" 
	    (slot-value c 'byte-code-function))))

(define-condition 
  illegal-argument (error)
  (message)
  (lambda (c s)
    (format s "Illegal argument.~&")
    (format s "        ~a~&" (slot-value c 'message))
    (std-error-function-report c s)))

(define-condition
  illegal-argument-type (illegal-argument)
  (type object)
  (lambda (c s)
    (format s "Illegal argument.~%")
    (format s "        ~s is not a ~a.~%" (slot-value c 'object)
                                          (slot-value c 'type))
    (std-error-function-report c s)))
    
(define-condition 
  illegal-number-of-arguments (illegal-argument)
  (number-of-arguments rest)
  (lambda (c s)
    (let ((argnum (slot-value c 'number-of-arguments)))
      (format s "Illegal number of arguments.~&")
      (format s "        ~a~&" (slot-value c 'message))
      (if (slot-value c 'rest) 
	(cond ((<= argnum 1)
	       (format s "        The function requires more than zero arguments.~&"))
	      ((> argnum 1)
	       (format s "        The function requires more than ~a arguments.~&" 
		       (1- argnum))))
	(cond ((zero? argnum)
	       (format s "        The function requires no argument.~&"))
	      ((= argnum 1)
	       (format s "        The function requires 1 argument.~&"))
	      ((> argnum 1)
	       (format s "        The function requires ~a arguments.~&" 
		       argnum))))
      (std-error-function-report c s))))

(define-condition
  arithmetic-error (error)
  ()
  (lambda (c s)
    (std-error-report c s "Arithmetic error.")))

(define-condition 
  division-by-zero (arithmetic-error illegal-argument-type)
  ()
  (lambda (c s)
    (std-error-report c s "Division by zero.")))

(define-condition
  io-error (error)
  ()
  "I/O-ERROR")

(define-condition
  read-error (io-error)
  (message)
  (lambda (c s)
    (format s "~a~%" (slot-value c 'message))
    (std-error-function-report c s)))

(define-condition 
  file-error (error)
  (pathname message)
  (lambda (c s)
    (format s "~a~%" (slot-value c 'message))
    (std-error-function-report c s)))

(define-condition
  stream-error (error)
  (stream message)
  "STREAM-ERROR")

(define-condition
  compile-error (error simple-condition)
  ()
  (lambda (c s)
    (format s "Compile error.~&")
    (format s "        ")
    (apply format s (slot-value c 'format-string)
                    (slot-value c 'format-arguments))))

(define-condition
  system-error (error)
  (message)
  (lambda (c s)
    (format s messgae)))

;
;     TUTScheme debugger system.
;         By N.Watanabe Jul 30, 1992
;
;       version 3.3   Apr. 23, 1993
;

(define *error-output* (console-output-port))
(define *error-input*  (console-input-port))
(define *return-debugger*)
(define *debugger-level* 0)
(define *dbg-cont-stack*)   
(define *condition-stack*)
(define *dbg-commands*) ; ver 3.1
(define *back-trace-cont* #f) ; ver 3.2
(define *condition*)

(define (invoke-debugger condition) ; ver 3.3
    (let ((return-value '())
          (dbg-level *debugger-level*)
          (current-i-port (current-input-port))
          (current-o-port (current-output-port)))
      (cond ((not (condition-object? condition))
             (error 'illegal-argument
                    'function invoke-debugger
                    'arguments (list condition)
                    'message "Argument must be a condition object."))
            (else
              (set! *debugger-level* (1+ *debugger-level*))
              (set! return-value
                    (call/cc 
                      (lambda (c)
                        (set! *dbg-cont-stack* (cons c *dbg-cont-stack*))
                        (set! *condition-stack* (cons condition 
                                                      *condition-stack*))
                        (set! *condition* condition)
                        (set! *return-debugger* c)
                        (mydeb condition))))
              (if *back-trace-cont* 
                  (*back-trace-cont* (back-trace)))
              (set! *dbg-cont-stack*  (cdr *dbg-cont-stack*))
              (set! *condition-stack* (cdr *condition-stack*))
              (set! *condition* (car *condition-stack*))
              (set! *return-debugger* (car *dbg-cont-stack*))
              (set! *debugger-level*  dbg-level)
              (if (= dbg-level 0)
                  (begin 
                    (set! *dbg-cont-stack* '())
                    (set! *condition-stack* '())))
              return-value))))

(define (dbg-message condition)
  (if (not (condition-object? condition))
      (error 'illegal-argument
             'function dbg-message
             'arguments (list condition)
             'message "Argument must be a condition object.~&")
      (begin
        (format  *error-output* "~&")
;        (format *error-output* "~&TUTScheme debugger system.~%")
        (print-condition-message condition)
;        (format *error-output* "~&To return to top level, type :Q .")
        (format *error-output* "~&To print debugger commands, type :H.~%"))))

(define (mydeb condition)
  (if (not (condition-object? condition))
      (error 'illegal-argument
             'function mydeb
             'arguments (list condition)
             'message "Argument must be a condition object.~&")
      (let ((prompt "~&Debug[~a]> ")
            (input '()))
        (dbg-message condition)
        (do () (#f)
          (format *error-output* prompt *debugger-level*)
          (flush-port *error-output*)
          (set! input (read *error-input*))
          (if (not (eof-object? input))
              (let ((retval (debug-eval input condition)))
                (format *error-output* "~a" 
                  (if (condition-object? retval)
                      (condition-symbol retval)
                      retval)))
              (quit-dbg condition))))))

(define (debug-eval exp condition)
  (cond ((symbol? exp)
         (if (assq exp *dbg-commands*) 
             (dispatch-dbg-command exp condition)
             (get-symbol-value exp)))
        (else 
          (eval exp))))

(define (nlist x)
  (if (zero? x) 
      '()
      (cons '() (nlist (1- x)))))

(macro define-debugger-command
  (lambda (form)
    (let ((command-name   (cadr    form))
          (condition-list (caddr   form))
          (help-string    (cadddr  form))
          (body           (cadddr (cdr form))))
      `(define-debugger-command* (quote ,command-name)
                                 (quote ,condition-list)
                                 ,help-string
                                 ,body))))

(define (define-debugger-command* com-name condition-list help-str body)
  (let ((errmsg '())
        (errobj  '())
        (errtype '()))
    (cond ((not (symbol? com-name))
           (set! errobj  com-name)
           (set! errtype "symbol"))
          ((not (list? condition-list))
           (set! errobj  condition-list)
           (set! errtype "list"))
          ((not (string? help-str))
           (set! errobj  help-srt)
           (set! errtype "string"))
          ((not (function? body))
           (set! errobj  body)
           (set! errtype "function")))
    (cond ((null? errtype)       ; no argument errors.
           (set! *dbg-commands*
                 (cons (list com-name condition-list help-str body)
                       *dbg-commands*))
           com-name)
          (else   ; when a argument error is detected.
            (error 'illegal-argument-type
                   'function  define-debugger-command
                   'arguments (list com-name condition-list help-str body)
                   'object    errobj
                   'type      errtype)
            #f))))

(define (dispatch-dbg-command com condition)
  (define (foo fun arg1 arg2)
    (cond ((null? arg2) #f)
          ((fun arg1 (car arg2)) #t)
          (else (or (foo fun arg1 (cdr arg2))))))
  (let ((com-obj   (assq com *dbg-commands*))
         (cond-list '()))
    (if com-obj
        (begin
          (set! cond-list (cadr com-obj))
          (if (or (foo condition-class?    condition cond-list)
                  (foo condition-subclass? condition cond-list))
              ((cadddr com-obj) condition)
              (warn "Sorry, you can not use this command.")))
        '())))
    
(define (print-dbg-commands condition stream)
  (define (foo fun arg1 arg2)
    (cond ((null? arg2) #f)
          ((fun arg1 (car arg2)) #t)
          (else (or (foo fun arg1 (cdr arg2))))))
  (format stream "~&Debugger commands~&")
  (for-each (lambda (x)
              (let ((cond-list (cadr x)))
                (if (or (foo condition-class?    condition cond-list)
                        (foo condition-subclass? condition cond-list))
                    (format stream "  ~a    ~a~&" (car x) (caddr x)))))
            *dbg-commands*)
  (format stream "~&"))

;  Get debugger command function 
;
(macro get-debugger-command-function
  (lambda (form)
    (let ((cmd (cadr form)))
      `(get-debugger-command-function* ',cmd))))

(define (get-debugger-command-function* cmd)
  (let ((com-obj   (assq cmd *dbg-commands*)))
    (if com-obj
        (cadddr com-obj)
        #f)))
;
;  Definition of the debug level commands.
;    for debugger version 3.3
;

(define *dbg-commands*)

(define-debugger-command :R (condition) 
  "Return to previous level."
  (lambda (c)
    (*return-debugger* #t)))

(define-debugger-command :v (condition)
  "return to previous level with return Value."
  (lambda (c)
    (*return-debugger* (begin (format *error-output*
                                      "~&Enter new expression > ")
                              (eval (read *error-input*))))))

(define (quit-dbg c)
    (format *error-output*
            "Return to top level.~%")
    (return-to-sctop))

(define-debugger-command :Q (condition)
  "Quit debug level and return to top level."
  quit-dbg)

(define (print-condition-message condition)
    (if (not (condition-object? condition))
        (error 'illegal-argument
               'function print-condition-message
               'arguments (list condition)
               'message "Argument must be a condition object.")
        (condition-report condition *error-output*)))

(define-debugger-command :M (condition)
  "print the signaled condition Message."
  print-condition-message)

(define-debugger-command :H (condition)
  "print the Help message of debugger commands."
  (lambda (c)
    (print-dbg-commands c *error-output*)
    #t))

(define-debugger-command :c (condition)
  "print the signaled Condition."
  (lambda (condition)
    (if (not (condition-object? condition))
        (error 'illegal-argument
               'function print-signaled-condition
               'arguments (list condition)
               'message "Argument must be a condition object.")
        (format *error-output* "~a~&" (condition-symbol condition)))))

(define-debugger-command :b (condition)
  "execute the Back trace function."
  (lambda (c)
    (let/cc-cs cc 
      (set! *back-trace-cont* cc)
      (*return-debugger* '()))
    (set! *back-trace-cont* #f)))

(define-debugger-command :a (illegal-argument arithmetic-error)
  "enter the new Arguments for the function and restart from it."
  (lambda (condition)
    (let* ((function  '())
           (arguments '())
           (argc      '())
           (num 1))
      (define (baka x)
        (format *error-output* "Argument #~a = ~a~&" num x)
        (format *error-output* "Enter New argument > ")
        (set! x (eval (read *error-input*)))
        (set! num (1+ num))
        x)
      (if (condition-subclass? condition 'byte-code-error)
          (format *error-output* 
                  "~&Sorry, you can not use this commnad!~&")
          (begin
            (set! function  (error-function  condition))
            (set! arguments (error-arguments condition))
            (set! argc      (argument-number condition))
            (format *error-output* 
                    "~&Enter arguments and restart the function.~&")
            (if (= (length arguments) argc)
                '()
                (set! arguments (nlist argc)))
            (set! arguments (map baka arguments))
            (if (function? *return-debugger*)
                (*return-debugger* (apply function arguments))
                (apply function arguments)))))))

(define-debugger-command :o (illegal-argument-type arithmetic-error)
  "enter the One arguments for the function and restart from it."
  (lambda (condition)
    (let* ((function  '())
           (arguments '())
           (argument  '())
           (num 1))
      (define (change n value)
        (let ((place arguments))
          (do ((i 1 (1+ i)))
              ((>= i n) (set-car! place value))
              (set! place (cdr place)))
          arguments))
      (define (nth n x)
        (let ((place x))
          (do ((i 1 (1+ i)))
              ((>= i n))
              (set! place (cdr place)))
          (car place)))
      (if (condition-subclass? condition 'byte-code-error)
          (format *error-output* 
                  "~&Sorry, you can not use this commnad!~&")
          (begin
            (set! function  (error-function  condition))
            (set! arguments (error-arguments condition))
            (format *error-output* 
                    "~&Enter arguments number > ")
            (set! num (read *error-input*))
            (if (and (<= num (length arguments))
                     (>= num  1))
                (begin 
                  (format *error-output*
                          "~&Argument #~s is ~s.~%" num (nth num arguments))
                  (format *error-output*
                          "~&Enter new argument > ")
                  (set! arguments (change num (read *error-input*)))
                  (if (function? *return-debugger*)
                      (*return-debugger* (apply function arguments))
                      (apply function arguments)))
                (format *error-output*
                        "~&Command failed!~%")))))))

(define-debugger-command :f (not-function-apply illegal-argument)
  "enter the new Function and restart."
  (lambda (condition)
    (define (enter-function)
      (format *error-output* "~&Enter new function > ")
      (eval (read *error-input*)))
    (let ((function  '())
          (arguments '())
          (argc      '()))
      (if (condition-subclass? condition 'byte-code-error)
          (format *error-output* 
                  "~&Sorry, you can not use this commnad!~&")
          (begin
            (set! function  (enter-function))
            (set! arguments (error-arguments condition))
            (set! argc      (argument-number condition))
            (if (function? *return-debugger*)
                (*return-debugger* (apply function arguments))
                (apply function arguments)))))))
